package sort;

public class SortableDataWithStatistics<T> implements SortableData<T> {

	private SortableData<? extends T> data;

	int nswap;

	int nget;

	int ncompare;

	public SortableDataWithStatistics(SortableData<? extends T> data) {
		this.data = data;
		nswap = nget = ncompare = 0;
	}

	public int size() {
		return data.size();
	}

	public void swap(int i, int j) {
		nswap++;
		data.swap(i, j);
	}

	public T get(int i) {
		nget++;
		return data.get(i);
	}

	public int compare(int i, int j) {
		ncompare++;
		return data.compare(i, j);
	}

	public int getSwapStat() {
		return nswap;
	}

	public int getGetStat() {
		return nget;
	}

	public int getCompareStat() {
		return ncompare;
	}
}