import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

import sort.AsciiTracer;
import sort.InsertionSort;
import sort.QuickSort;
import sort.Sort;
import sort.SortableComparableData;
import sort.SortableDataWithComparator;
import sort.SortableDataWithStatistics;
import sort.SortableDataWithTracer;
import sort.Sorts;
import sort.SwapableArray;
import sort.SortableData;
import sort.SwapableList;
import sort.WinTracer;

/*
 * Created on 24 oct. 2004
 *
 */

/**
 * @author baudon
 * 
 */
public class TestSort {

	public static void sortAndPrint(SortableData<?> sd, Sort sort) {
		sort.doSort(sd);
		for (int i = 0; i < sd.size(); ++i) {
			System.out.print(sd.get(i) + " ");
		}
		System.out.println();
	}

	public static <T> void initList(List<T> l, T[] a) {
		l.clear();
		for (T t : a) {
			l.add(t);
		}
	}

public static void main(String[] args) {
		String[] args2 = new String[args.length];
		System.arraycopy(args, 0, args2, 0, args.length);
		Sort isort = new InsertionSort();
		Sort qsort = new QuickSort();

		sortAndPrint(new SortableComparableData<String>(
				new SwapableArray<String>(args2)), isort);
		System.arraycopy(args, 0, args2, 0, args.length);
		sortAndPrint(new SortableComparableData<String>(
				new SwapableArray<String>(args2)), qsort);

		List<String> ls = new ArrayList<String>();
		initList(ls, args);
		sortAndPrint(new SortableComparableData<String>(
				new SwapableList<String>(ls)), isort);
		initList(ls, args);
		for (String s : ls) {
			System.out.println(s + " " + s.hashCode());
		}
		sortAndPrint(new SortableDataWithComparator<String>(
				new SwapableList<String>(ls), new Comparator<Object>() {
					public int compare(Object o1, Object o2) {
						int h1 = o1.hashCode();
						int h2 = o2.hashCode();
						return h1 < h2 ? -1 : (h1 == h2 ? 0 : 1);
					}
				}

		), qsort);

		initList(ls, args);
		sortAndPrint(new SortableDataWithComparator<String>(
				new SwapableList<String>(ls), new Comparator<String>() {
					public int compare(String s1, String s2) {
						return -s1.compareTo(s2);
					}
				}), qsort);

		initList(ls, args);
		SortableData<String> sd = new SortableComparableData<String>(new SwapableList<String>(ls));
		SortableDataWithTracer<String> sdwt = new SortableDataWithTracer<String>(sd);
		sdwt.addObserver(new AsciiTracer());
		sdwt.addObserver(new WinTracer(sdwt, sd));
		SortableDataWithStatistics<String> sdws = new SortableDataWithStatistics<String>(sdwt);
		sortAndPrint(sdws, qsort);
		System.out.println("Stats: " + sdws.getSwapStat() + " swap, " + sdws.getGetStat() + " get, " + sdws.getCompareStat() + " compare");

		initList(ls, args);
		Sorts.quickSort(ls);
		for (String s : ls) {
			System.out.print(s + " ");
		}
		System.out.println();
	}}
